︠36a99781-97c5-4b4c-98ca-0edf683f46fdi︠
%md
# Cython

## A Very Brief Introduction!

Cython is a variant of Python which can be compiled directly to C. If used judiciously, this can be used to make certain code much faster with very little effort on your part.

Cython website: http://cython.org/


︡6675e244-c44f-455e-9b5f-f6a373718224︡{"done":true,"md":"# Cython\n\n## A Very Brief Introduction!\n\nCython is a variant of Python which can be compiled directly to C. If used judiciously, this can be used to make certain code much faster with very little effort on your part.\n\nCython website: http://cython.org/"}
︠73345105-f24d-4370-90df-1b1330609f0bs︠
# recall
import math
def sin_sum(m):
    return sum(math.sin(i) for i in xrange(m))
︡1b181d58-15cc-421b-aebb-2f1b54cbdba3︡{"done":true}︡
︠2f92de25-988a-40e5-b112-131f936a3a82s︠
print sin_sum(10000)
︡e5f5e978-2702-4fcf-aec7-c1f9f843c288︡{"stdout":"1.93950541068\n"}︡{"done":true}︡
︠3d6391f4-9d3a-485f-b068-9b2120a6fc97s︠
%timeit sin_sum(10000)
︡e1b1f1d6-1af1-4621-af18-03675e8ca091︡{"stdout":"125 loops, best of 3: 3.74 ms per loop"}︡{"stdout":"\n"}︡{"done":true}︡{"stdout":"\n"}︡{"done":true}
︠99d1e395-f0bb-4d4a-8a7c-2643c7fcd98f︠
︡cb524d95-f0ec-4c37-901e-44747eb0d135︡
︠b029c1a7-d48b-49f3-968a-a7dd874ad720s︠
%cython
import math
def sin_sum_cython0(m):
    return sum(math.sin(i) for i in xrange(m))
︡c242f05e-7834-46a6-97cc-3d95db98dd36︡{"stdout":"Defined math, sin_sum_cython0"}︡{"stdout":"\n"}︡{"file":{"filename":"/projects/8a2a5bba-2f6d-43ba-8570-fa9e4672e2b1/.sage/temp/compute5-us/5216/spyx/_projects_8a2a5bba_2f6d_43ba_8570_fa9e4672e2b1__sage_temp_compute5_us_5216_dir_FTE6kH_a_pyx/_projects_8a2a5bba_2f6d_43ba_8570_fa9e4672e2b1__sage_temp_compute5_us_5216_dir_FTE6kH_a_pyx_0.html","show":true,"text":"Auto-generated code...","url":"/8a2a5bba-2f6d-43ba-8570-fa9e4672e2b1/raw/.sage/temp/compute5-us/5216/spyx/_projects_8a2a5bba_2f6d_43ba_8570_fa9e4672e2b1__sage_temp_compute5_us_5216_dir_FTE6kH_a_pyx/_projects_8a2a5bba_2f6d_43ba_8570_fa9e4672e2b1__sage_temp_compute5_us_5216_dir_FTE6kH_a_pyx_0.html"},"once":false}︡{"done":true}︡
︠292df5d4-26bb-47d2-88cf-36aa9a6ff718s︠
%timeit sin_sum_cython0(10000)
︡bbabfa01-7935-42d3-afba-75838f47faef︡{"stdout":"625 loops, best of 3: 2.2 ms per loop"}︡{"stdout":"\n"}︡{"done":true}︡
︠05585bcf-eb1d-4e0e-ab62-f713393cbfe9s︠
# not that impressive... but *typical*
3.74/2.2
︡ca8f5b87-2e14-4bb5-a5c8-d30123a30cc8︡{"stdout":"1.70000000000000\n"}︡{"done":true}︡
︠11b84cb0-214e-42bc-99d3-0a307c0e4dcfi︠
%md
Talk about type declaration and direct calling of C code...
︡ccbd7679-1d1b-4765-875c-7bf0fd6c45fe︡︡{"done":true,"md":"Talk about type declaration and direct calling of C code..."}
︠ba7a15ed-c3a6-41c6-8ef0-8d5ce5bdb8d0s︠
%cython

cdef extern from "math.h":
    cdef double sin(double)

def sin_sum_cython(int m):
    cdef double s = 0
    cdef int k
    for k in range(m):
        s += sin(k)
    return s
︡261e276d-37d8-4924-b3ba-01a1dbb5c0cc︡{"stdout":"Defined sin_sum_cython"}︡{"stdout":"\n"}︡{"file":{"filename":"/projects/8a2a5bba-2f6d-43ba-8570-fa9e4672e2b1/.sage/temp/compute5-us/5216/spyx/_projects_8a2a5bba_2f6d_43ba_8570_fa9e4672e2b1__sage_temp_compute5_us_5216_dir_PITpvX_a_pyx/_projects_8a2a5bba_2f6d_43ba_8570_fa9e4672e2b1__sage_temp_compute5_us_5216_dir_PITpvX_a_pyx_0.html","show":true,"text":"Auto-generated code...","url":"/8a2a5bba-2f6d-43ba-8570-fa9e4672e2b1/raw/.sage/temp/compute5-us/5216/spyx/_projects_8a2a5bba_2f6d_43ba_8570_fa9e4672e2b1__sage_temp_compute5_us_5216_dir_PITpvX_a_pyx/_projects_8a2a5bba_2f6d_43ba_8570_fa9e4672e2b1__sage_temp_compute5_us_5216_dir_PITpvX_a_pyx_0.html"},"once":false}︡{"done":true}︡
︠5faff1b9-566e-4614-9e75-14822e656171s︠
%timeit sin_sum_cython(10000)
︡585c9fde-2f6d-4b3d-8659-e350e9e27fc3︡{"stdout":"625 loops, best of 3: 434 µs per loop"}︡{"stdout":"\n"}︡{"done":true}︡
︠d1f1f78e-3db8-4153-b505-c3dc2d0bc5c9s︠
2.2/.434
︡6246967f-17e4-4f6d-a5cc-6b894d5a7d66︡{"stdout":"5.06912442396313\n"}︡{"done":true}︡
︠10d649b1-153d-4a6b-ab1c-d793ff5785a1s︠
def sin_sum0(m):
    return float(sum(sin(i) for i in xrange(m)))
︡c16ea070-7873-4ac9-881e-ec1158da4c54︡{"done":true}︡
︠270fe33d-32ad-4b72-8e64-4a681d38e90ds︠
%time sin_sum0(10000)
︡46846237-7d0a-4c66-a776-519daa341204︡{"stdout":"1.939505410680705"}︡{"stdout":"\n"}︡{"stdout":"CPU time: 3.34 s, Wall time: 4.56 s\n"}︡{"done":true}︡
︠94eb4b6f-1bac-4e9e-92d2-90f62bbed85ds︠
# speedup over original: 10000x
3.34/.000434
︡01769373-d90b-4e05-b96b-4e0ed9f6c361︡{"stdout":"7695.85253456221\n"}︡{"done":true}︡
︠dc8cdd4a-31c6-47b2-80a5-dd3d0422eb68i︠
%md
You probably can't beat this by much without a new idea...
︡dff7a7c1-5b4d-4c3f-8b7f-c1a4e5c6fb3d︡︡{"done":true,"md":"You probably can't beat this by much without a new idea..."}
︠e6965473-a0c9-421d-b577-96c3c32cf27ai︠
%md
Aside: you might wonder why the Cythonization process couldn't be incorporated directly into the Python interpreter, so that code is automatically fast while still being easy to read and write. This is the design principle behind a closely related language called Julia, which is also available within SageMathCloud but is much newer (and hence less established) than Python.
︡da3867c5-b184-4651-ac9b-48f7733f636a︡{"done":true,"md":"Aside: you might wonder why the Cythonization process couldn't be incorporated directly into the Python interpreter, so that code is automatically fast while still being easy to read and write. This is the design principle behind a closely related language called Julia, which is also available within SageMathCloud but is much newer (and hence less established) than Python."}
︠56a1cbf9-595d-419f-96a0-60e4c93b838e︠









